#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <pthread.h>
#include <semaphore.h>

/* Taille de la salle d'attente */
#define NB_PLACES 5


void proc_coiffeur(void *ptr);
void proc_client(void *ptr);
int num_Digits(int num);

void proc_coiffeur(void *ptr)
{
	printf("#Coif: Ouverture du salon.\n");
	while(1){

	}
}

void proc_client(void *ptr)
{
	char * name = (char*)ptr;
	printf("\t@%s: Bonjour!\n",name);
}

int main(void)
{
	/* Thread du coiffeur */
	pthread_t lecoiffeur;
	/* Ptr sur thread pour les clients */
	pthread_t *ptr_sur_thread;
	int nb_client=0;
	char* c_name;
	/* Init des semaphores */
	
	/* On demarre le coiffeur */
	pthread_create(&lecoiffeur, NULL, (void*)&proc_coiffeur, NULL);
	
	/* Quand le user fait un retour de chariot, on lance un client */
	while(1)
	{
		getchar();
		nb_client++;
		c_name=malloc((num_Digits(nb_client)+7)*sizeof(char)+1);
		sprintf(c_name,"client-%d",nb_client);
		printf("Nouveau Client.\n");
		ptr_sur_thread=(void*)malloc(sizeof(pthread_t));
		pthread_create((void*)&ptr_sur_thread, NULL, (void*)&proc_client, c_name);
	}
	/* Quand le coiffeur meurt, on exit */
	pthread_join(lecoiffeur, NULL);
	return 0;
}
/**
 * Count the number of Digits in a unsigned long
 */
int num_Digits(int num){
	if ( num < 10 )
		return 1;
	else
		return 1+num_Digits(num/10);
}
